"""
Django settings for slarc project.

Generated by 'django-admin startproject' using Django 2.2.3.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
from celery.schedules import crontab

BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'kzz1tswko1=6w^^wj%lev--rr7!dl$=4cm6oucsr8!gc(79$yr'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['*', ]

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

    'django_celery_beat',
    'corsheaders',
    'rest_framework',
    'drf_yasg',

    'api',
    'external',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'slarc.urls'

TEMPLATES = [
    {
        'BACKEND' : 'django.template.backends.django.DjangoTemplates',
        'DIRS'    : [],
        'APP_DIRS': True,
        'OPTIONS' : {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'slarc.wsgi.application'

# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static')

LOGGING = {
    'version'                 : 1,
    'disable_existing_loggers': False,
    'formatters'              : {
        'standard': {
            'format' : "[%(asctime)s] - [%(module)s:%(lineno)s] - [%(levelname)s] %(message)s",
            'datefmt': "%d/%b/%Y %H:%M:%S%Z"
        },
    },
    'handlers'                : {
        'console': {
            'level'    : 'DEBUG',
            'class'    : 'logging.StreamHandler',
            'formatter': 'standard'
        },
    },
    'loggers'                 : {
        'django'   : {
            'handlers' : ['console'],
            'propagate': True,
            'level'    : 'DEBUG'
        },
        'api'      : {
            'handlers': ['console'],
            'level'   : 'DEBUG'
        },
        'VCGClient': {
            'handlers': ['console'],
            'level'   : 'INFO'
        },
    }
}

CORS_ORIGIN_ALLOW_ALL = True

# ==================================
#   RABBITMQ SETTINGS
# ==================================
RABBITMQ_USER = os.getenv('RABBITMQ_USER')
RABBITMQ_PASSWORD = os.getenv('RABBITMQ_PASSWORD')
RABBITMQ_HOST = os.getenv('RABBITMQ_HOST')
RABBITMQ_PORT = os.getenv('RABBITMQ_PORT', default=5672)
RABBITMQ_VHOST = os.getenv('RABBITMQ_VHOST', default='/')

# ==================================
#   CELERY SETTINGS
# ==================================
# Database used as celery results backend
CELERY_POSTGRES_DATABASE = os.getenv('CELERY_POSTGRES_DATABASE', default='celery')
CELERY_POSTGRES_USER = os.getenv('CELERY_POSTGRES_USER')
CELERY_POSTGRES_PASSWORD = os.getenv('CELERY_POSTGRES_PASSWORD')
CELERY_POSTGRES_HOST = os.getenv('CELERY_POSTGRES_HOST')
CELERY_POSTGRES_PORT = os.getenv('CELERY_POSTGRES_PORT', default=5432)
CELERY_BROKER_URL = 'amqp://{}:{}@{}:{}/{}'.format(
    RABBITMQ_USER, RABBITMQ_PASSWORD, RABBITMQ_HOST, RABBITMQ_PORT, RABBITMQ_VHOST)
CELERY_RESULT_BACKEND = 'db+postgresql://{}:{}@{}/{}'.format(
    CELERY_POSTGRES_USER, CELERY_POSTGRES_PASSWORD, CELERY_POSTGRES_HOST, CELERY_POSTGRES_DATABASE
)
CELERY_ACCEPT_CONTENT = ['json']
CELERY_TASK_SERIALIZER = 'json'
CELERY_RESULT_SERIALIZER = 'json'
CELERY_TASK_ACKS_LATE = True
CELERY_TIMEZONE = 'UTC'
CELERY_BEAT_SCHEDULE = {
    'update_daily_slo_values'  : {
        'task'    : 'api.tasks.check_slo_nullification',
        'schedule': crontab(hour=0, minute=10),
        'kwargs'  : {"billing_cyle": "daily"}
    },
    'update_weekly_slo_values' : {
        'task'    : 'api.tasks.check_slo_nullification',
        'schedule': crontab(day_of_week=1, hour=0, minute=0),
        'kwargs'  : {"billing_cyle": "weekly"}
    },
    'update_monthly_slo_values': {
        'task'    : 'api.tasks.check_slo_nullification',
        'schedule': crontab(day_of_month=1, hour=0, minute=0),
        'kwargs'  : {"billing_cyle": "monthly"}
    },
    'update_yearly_slo_values' : {
        'task'    : 'api.tasks.check_slo_nullification',
        'schedule': crontab(month_of_year=1, day_of_month=1, hour=0, minute=0),
        'kwargs'  : {"billing_cyle": "yearly"}
    },
    'notify_for_sla_breakage'  : {
        'task'    : 'api.tasks.notify_for_sla_breakage',
        'schedule': crontab(minute=os.getenv("SLA_CHECK_PERIOD", "*/2")),
    },
    'check_sla_end'            : {
        'task'    : 'api.tasks.check_sla_end',
        'schedule': crontab(minute='*')
    }
}

# ==================================
#   REDIS SETTINGS
# ==================================
REDIS_HOST = os.getenv('REDIS_HOST')
REDIS_PORT = os.getenv('REDIS_PORT', default=6379)
REDIS_PASSWORD = os.getenv('REDIS_PASSWORD', default=None)
REDIS_FILE_DATABASE = 0  # Database number used to store temporal tot part files
REDIS_CACHE_DATABASE = 1  # Database number that the django cache & session use as a backend
REDIS_URL = "redis://{}:{}/{}".format(REDIS_HOST, REDIS_PORT, REDIS_CACHE_DATABASE)

# ==================================
#   CACHE SETTINGS
# ==================================
CACHES = {
    'default': {
        'BACKEND' : 'django_redis.cache.RedisCache',
        'LOCATION': REDIS_URL,
        "OPTIONS" : {
            "CLIENT_CLASS": "django_redis.client.DefaultClient",
            "PASSWORD"    : REDIS_PASSWORD
        },
    }
}
